////////////////////////////////// CONEXAO VIX ////////////////////////////////
// BRUNO MASSARA / VICTOR MALHEIROS / MARIO MARGOTTO / FELIPE BOSI
// www.territorios.org

import processing.video.*;
// Declara o objeto MovieMaker
MovieMaker mm;
// Variable for capture device
//Capture video;
Movie video;
// Previous Frame
PImage prevFrame;
// How different must a pixel be to be a "motion" pixel
float threshold = 50;
int f = 1;

int W = 640;
int H = 480;

/////////////////////////////////// setup /////////////////////////////////

void setup() {
  size(W,H);
   frameRate(f);
   // Cria objerto MovieMaker com tamanho, nome, frameRate, compressor codec e qualidade
  // mm = new MovieMaker (this, width, height, "timelapse.mov", 1, MovieMaker.H263, MovieMaker.HIGH);
   
  //video = new Capture(this, width, height, 30);
  video = new Movie(this, "uvv3.mov");
  video.play();
  video.loop();
  // Create an empty image the same size as the video
  prevFrame = createImage(W,H,RGB);
}

/////////////////////////////////// draw /////////////////////////////////

void draw() {
  
  if (video.width < W || video.height < H) return;
  
  //video.read();
  // Capture video
  if (video.available()) {
    // Save previous frame for motion detection!!
    prevFrame.copy(video,0,0,video.width,video.height,0,0,video.width,video.height); // Before we read the new frame, we always save the previous frame for comparison!
    prevFrame.updatePixels();
    video.read();
  }
  
  loadPixels();
  video.loadPixels();
  prevFrame.loadPixels();
  
  // Begin loop to walk through every pixel
  for (int x = 0; x < video.width; x ++ ) {
    for (int y = 0; y < video.height; y ++ ) {
      
      int loc = x + y*video.width;            // Step 1, what is the 1D pixel location
      color current = video.pixels[loc];      // Step 2, what is the current color
      color previous = prevFrame.pixels[loc]; // Step 3, what is the previous color
      
      // Step 4, compare colors (previous vs. current)
      float r1 = red(current); float g1 = green(current); float b1 = blue(current);
      float r2 = red(previous); float g2 = green(previous); float b2 = blue(previous);
      float diff = dist(r1,g1,b1,r2,g2,b2);
      
      // Step 5, How different are the colors?
      // If the color at that pixel has changed, then there is motion at that pixel.
      if (diff > threshold) { 
        // If motion, display black
        pixels[loc] = color(0);
      } else {
        // If not, display white
        pixels[loc] = color(255);
      }
    }
  }
  updatePixels();
  // adiciona os pixels da janela ao filme
  // mm.addFrame();
   saveFrame("Movie/##.jpg");
}

/////////////////////////////////// keypressed /////////////////////////////////
// desligado

void keyPressed(){
  if (key == 'm'){
    println("finalizando filme");
    // mm.finish();            //finaliza o video quando pressionamos m
  }
}

